close all; keep pphome; p=[]; 
%% init
m=-1.2; eps=1/100; lam=0; par=[m eps lam 0]; lx=[0.5 0.5]; nx=[20 20]; 
p=chinit(p,lx,nx,par); p=setfn(p,'2D'); p.nc.nq=1; 
p.fuha.qf=@qf; p.fuha.qfder=@qfder; p.sw.qjac=1; p.nc.ilam=[1,3]; % aux eqns 
p=findbif(p,3); p=cont(p,60); % first use findbif, then just cont
%% 1st BP, double, hence cswibra, also set usrlam for continuation
p0=cswibra('2D','bpt1'); p0.pm.resfac=1e-3; p0.usrlam=[-0.5 0 0.5];
p=seltau(p0,3,'2D1-sp',3); p.sol.ds=0.1; p=pmcont(p,170); % spots
p=seltau(p0,1,'2D1-st',3); p.sol.ds=0.1; p=pmcont(p,130); % stripes
%% secondary
p=swibra('2D1-sp','bpt2','2D-sp1',0.1); pause; p=pmcont(p,20); 
%% 2nd BP, simple 
p=swibra('2D','bpt2','2D2',0.1); p=pmcont(p,110); 
%% 3rd NP, double again 
p0=cswibra('2D','bpt3',aux); p0.pm.resfac=1e-3;
p=seltau(p0,1,'2D3-sp',3); p.sol.ds=0.1; p=pmcont(p,90); 
p=seltau(p0,3,'2D3-st',3); p.sol.ds=0.1; p=pmcont(p,40); 
%% BD plot E over m
figure(3); clf; plotbra('2D','pt90','lsw',0); 
plotbra('2D1-sp','pt160','cl','b'); plotbra('2D1-st','pt120','cl','r'); 
plotbra('2D3-sp','pt90','cl','b'); plotbra('2D3-st','pt40','cl','r'); 
plotbra('2D2','pt110','cl','m'); 
%% BD plot E over m, zoom into 1-sp near m=0
figure(3); clf; plotbra('2D1-sp','pt100','cl','b','fp',67,'lp',130); ylabel('E');
%% BD plot E over m, with nice labels 
figure(3); clf; cmp=4; plotbra('2D','pt90','lsw',0); 
plotbra('2D1-sp','pt170','cl','b','lab',[43 95]); 
plotbra('2D1-st','pt120','cl','r','lab',36); 
plotbra('2D2','pt100','cl','m','lab',58);
plotbra('2D3-sp','pt80','cl','b'); plotbra('2D3-st','pt40','cl','r','lsw',0);
ylabel('E'); axis([-1.1 1.1 -0.25 0]); 
%% sol plots
mypsol('2D1-sp','pt43'); mypsol('2D1-sp','pt83'); 
mypsol('2D1-sp','pt95'); mypsol('2D1-st','pt36'); 
mypsol('2D2','pt58'); mypsol('2D3-sp','pt46'); 
