%% demo chemotax
% quasilinear system, here run with numerical G_u
%% Init
close all; lx=0.5; ly=2; nx=10; ny=round(ly*nx/lx); 
jac=0; % typically use num-jac; for 
p=[]; p=cheminit(p,lx,ly,nx,ny,jac); 
p=setfn(p,'p'); p.sw.spcalc=1; p.sw.verb=2; 
p.plot.pstyle=2; p.plot.pcmp=1; p.sw.jac=1; p=cont(p);
%% 5 bif. branches, low tolerance, switching off bifdetec for speed 
p=swibra('p','bpt1','q1',0.1); p.nc.tol=1e-6; pause
p.sw.bifcheck=0; p.sw.spcalc=0; p.sw.jac=0; p=cont(p,10); 
%% this one runs OK with jac=1
p=swibra('p','bpt2','q2',0.5); p.nc.tol=1e-6; 
p.sw.bifcheck=0; p.sw.spcalc=0; p.sw.jac=0; p=cont(p,10); 
%%
p=swibra('p','bpt3','q3',0.1); p.nc.tol=1e-6; 
p.sw.bifcheck=0; p.sw.spcalc=0; p.sw.jac=0; p=cont(p,5);
%%
p=swibra('p','bpt4','q4',0.5); p.nc.tol=1e-6; 
p.sw.bifcheck=0; p.sw.spcalc=0; p.sw.jac=0; p=cont(p,5); 
%%
p=swibra('p','bpt5','q5',0.25); p.nc.tol=1e-6; 
p.sw.bifcheck=0; p.sw.spcalc=0; p.sw.jac=0; p=cont(p); 
%% plot bifurcation diagram
figure(4);clf(4);cmp=1;
plotbra('p',4,cmp,'cl','k');
plotbra('q1',4,cmp,'cl','b');
plotbra('q2',4,cmp,'cl','r');
plotbra('q3',4,cmp,'cl','m');
plotbra('q4',4,cmp,'cl','c');
plotbra('q5',4,cmp,'cl','g');
%axis([10 22 0 0.8]);xlabel('\lambda');
ylabel('||u_1-1||_{L^1}/|\Omega|');
%% plot some solns 
plotsolf('q1','pt10',1,1,2); 
plotsolf('q2','pt10',2,1,2); 
%% check the diff matrices 
n=p.np; plotsol(p,1,1,1); ux=p.u; 
ux(1:n)=p.mat.Dy*p.u(1:n); %ux(1:n)=p.mat.M(1:n,1:n)\ux(1:n); 
plotsolu(p,ux,3,1,1); 
%%
[Gu,Gn]=jaccheck(p); Gd=abs(Gu-Gn); e1=max(max(Gd)); spy(Gd>e1/1000);