%% demo chemotax
% quasilinear system, now trying jac=1 on finer mesh; basically fails 
% EVEN THOUGH ||numjac-sGjac||_rel=O(10^-5) 
%% Init
close all; lx=0.5; ly=2; nx=10; ny=round(ly*nx/lx); 
p=[]; p=cheminit(p,lx,ly,nx,ny); p.sw.bifcheck=2; 
p=setfn(p,'tr'); p.sw.spcalc=1; p.nc.mu2=0.05; p=cont(p,30);
%% Bif branches, low tolerance, switching off bifdetec for speed 
p=swibra('pl','bpt1','q1l',0.1); p.nc.tol=1e-6;  
p.sw.bifcheck=0; p.sw.spcalc=0; p.nc.dsmax=0.5; p=cont(p,20); 
%% 2 stripes 
p=swibra('pl','bpt2','q2l',0.5); p.nc.tol=1e-8; 
p.sw.bifcheck=0; p.sw.spcalc=0; p=cont(p,15);
%% BP3, multiple 
aux=[]; aux.soltol=1e-20; aux.isotol=1e-12; aux.besw=0; aux.m=3;  
%aux.ali=[1 2 3]; aux.besw=1;
p0=cswibra('pl','bpt3',aux); p0.sw.bifcheck=0; p0.nc.tol=1e-6; p0.sw.spcalc=0;
%% 1 stripe, tiny loop
p=gentau(p0,1,'q3al'); p.sol.ds=-0.05; p=cont(p,25);
%% 1 stripe, tiny loop
p=gentau(p0,[0 0 1],'q3bl'); p.sol.ds=-0.05; p=cont(p,25);
%% 2 spots, with a  loop along the way 
p=swibra('pl','bpt4','q4l',0.1); p.nc.tol=1e-4; 
p.sw.bifcheck=0; p.sw.spcalc=0; p=cont(p,40); 
%% 3 spots 
p=swibra('pl','bpt5','q5l',0.1); p.nc.tol=1e-6; 
p.sw.bifcheck=0; p.sw.spcalc=0; p=cont(p,10); 
%% plot bifurcation diagram
figure(4);clf(4);cmp=1;
plotbra('pl',4,cmp,'cl','k'); plotbra('q1l',4,cmp,'cl',p2pc('b1'),'lab',10);
plotbra('q2l',4,cmp,'cl',p2pc('b2'),'lab',10); 
plotbra('q3al',4,cmp,'cl',p2pc('r1'),'lab',10);plotbra('q3bl',4,cmp,'cl',p2pc('b3'),'lab',10);
plotbra('q4l',4,cmp,'cl',p2pc('r2'),'lab',10); plotbra('q5l',4,cmp,'cl',p2pc('r3'),'lab',10);
%axis([10 22 0 0.8]);xlabel('\lambda');
ylabel('||u_1-1||_{L^1}/|\Omega|');
%% plot some solns 
plotsol('q1','pt10',1,1,2);pause; plotsol('q2','pt10',1,1,2); pause 
plotsol('q3a','pt10',1,1,2);pause; plotsol('q3b','pt10',1,1,2); pause 
plotsol('q4','pt10',1,1,2);pause; plotsol('q5','pt10',1,1,2); pause
plotsol('q6a','pt10',1,1,2);pause; plotsol('q6b','pt10',1,1,2); 
%% check the diff matrices 
n=p.np; plotsol(p,1,1,1); ux=p.u; 
ux(1:n)=p.mat.Dy*p.u(1:n); %ux(1:n)=smu(p,ux(1:n)); %ux(1:n)=p.mat.M(1:n,1:n)\ux(1:n); 
plotsolu(p,ux,3,1,1); 
%% check Jacobians
p.nc.del=1e-6; 
[Gu,Gn]=jaccheck(p); Gd=abs(Gu-Gn); e1=max(max(Gd)); figure(4); clf; spy(Gd>e1/4);
%%
n=p.np; plotsol(p,1,1,1); u=p.u(1:n); v=p.u(n+1:2*n); 
Kvud=getKuvd(p,u,v); 