%% cell 1: init, and continuation of trivial branch 
p=[]; lx=pi; nx=30; p=cGLinit(p,lx,nx); % initialize  
par=[-0.1; 0; 0;  0;  -1; 1; 0;  0;   1];  
%     r  s  nu  mu  c3 c5  ga  sym  l
u=zeros(p.np,1); v=u; p.u=[u;v; par]; % initial guess (here trivial) and pars 
dir='0'; p=setfn(p,dir); p=cont(p,10); 
%% cell 2 - switch to front-mode for one step
p=swibra('0','bpt2','ini',0.01); p.sw.bifcheck=0; p=cont(p,1);
%% cell 3 - add phase conditions and continue
p=loadp('ini','pt1','stand'); p=resetc(p); 
p.nc.ilam=[1;2;3]; p.nc.nq=2; p.fuha.qf=@qf_sym;
p.sw.qjac=1; p.fuha.qfder=@qfder_sym; 
p.sw.bprint=[2;3]; clf(2); p.nc.dsmax=0.5; p=cont(p,20); 
%% cell 4 - continue in family given by rotation symmetry
p=loadp('stand','pt20','rot'); p=resetc(p); clf(2); p.nc.lammax=pi; 
p.nc.ilam=[8;2;3]; p=cont(p,30);  % L2-norm is of the first component only
%% cell 5 - increase domain size and refine mesh
p=loadp('stand','pt20','dsize'); p=resetc(p); clf(2);
%%
p.nc.ilam=[9;2;3]; p.plot.bpcmp=9;
p.sol.ds=-0.1; p.nc.dsmax=0.1; p.nc.lammin=0.5; p=cont(p,10);
p=meshada(p,'ngen',3,'sig',1e-4); 
p.nc.dsmax=0.1; p.nc.lammin=0.25; p=cont(p,10);
%% cell 6 - nonzero frequency/speed through gamma
p=loadp('dsize','pt10','move-'); p=resetc(p); clf(2);
p.nc.ilam=[7;2;3]; p.branch=[bradat(p); p.fuha.outfu(p,p.u)]; 
p.nc.lammin=-1; p.plot.bpcmp=2; p=cont(p,22);
p=loadp('dsize','pt10','move+'); p=resetc(p); p.sol.ds=-p.sol.ds; 
p.nc.ilam=[7;2;3]; p.branch=[bradat(p); p.fuha.outfu(p,p.u)]; 
p.nc.lammin=-1; p.plot.bpcmp=2; p=cont(p,22);
%% plotting for cmds3 - NBC 
figure(3); clf; plotbra('stand','pt20',3,0,'cl','black','lab',20); pause
plotsol('stand','pt20'); pause; plotsol('rot','pt10'); pause; 
plotsol('dsize','pt10'); pause; 
plotsol('move-','pt20'); pause; plotsol('move+','pt20'); 
%% BD plotting 
figure(3); clf; plot([-0.03 -0.02],[0 0],'-k',[-0.03 -0.02],[0 0],'-b');  
plotbra('move-','pt20',3,2,'cl','k','lab',20,'lw',2);
plotbra('move-','pt20',3,3,'cl','b','lab',20,'lw',2); 
plotbra('move+','pt20',3,2,'cl','k','lab',20,'lw',2); 
plotbra('move+','pt20',3,3,'cl','b','lab',20,'lw',2); 
axis([-0.02 0.02 -0.011 0.011]); ylabel(''); legend('s','\nu'); 
